require 'omniauth-oauth2'

module OmniAuth
  module Strategies
    class Elcurator < OmniAuth::Strategies::OAuth2
      option :name, 'elcurator'

      option :client_options, {
        :site => 'https://www.elcurator.net',
        :authorize_url => '/oauth/authorize',
        :token_url => '/oauth/token'
      }

      uid { raw_info['id'] }

      info do
        prune!(
          {
            :first_name => raw_info['first_name'],
            :last_name => raw_info['last_name'],
            :email => raw_info['email']
          }
        )
      end

      extra do
        prune!({:raw_info => raw_info})
      end

      def request_phase
        options[:response_type] ||= 'code'
        super
      end

      def callback_phase
        request.params['state'] = session['omniauth.state']
        super
      end

      def build_access_token
        access_token = super
        token = eval(access_token.token)['token']
        @access_token = ::OAuth2::AccessToken.new(client, token, access_token.params)
      end

      def raw_info
        @raw_info ||= access_token.get('/api/open/v1/users/current').parsed
      end

      private

      def prune!(hash)
        hash.delete_if do |_, value|
          prune!(value) if value.is_a?(Hash)
          value.nil? || (value.respond_to?(:empty?) && value.empty?)
        end
      end
    end
  end
end